import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.neighbors import KNeighborsClassifier
import sklearn.metrics as metrics

# Vamos a realizar boostrap
n = 1000

# Tenemos que cargar los datos del Iris y como son dos
# clases tenemos que usar solo dos de las tres 
D = np.loadtxt( "iris.csv", delimiter=',', skiprows=1 )
print( D.shape )

# No estoy usando los datos de la tercera clase
X = D[0:100, 0:2]
y = D[0:100, 4]
print( X.shape )
print( y.shape )

vexactitud = np.zeros( (n,) )

# Generamos el modelo del clasificador
kvecinos = KNeighborsClassifier( n_neighbors=1 )

i=0
while i < n :
	# Separamos los datos para entrenamiento y prueba
	X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y )


	kvecinos.fit( X_entrena, y_entrena )
 
	# Probamos el modelo 
	y_estimadas = kvecinos.predict( X_prueba )

	# Calculamos la exactitud
	vexactitud[i] = metrics.accuracy_score( y_prueba, y_estimadas )

	i += 1

print( vexactitud.shape )
print( "Exactitud media:", np.mean( vexactitud )  )
print( "Exactitud dev. est.", np.std( vexactitud ) )

